Summary: 3M Touch Screen Driver
Name:  TWDrv
Version: 5.64
Release: 1.0
Group:  System Environment/Kernel
License: Proprietary
Vendor:  3M Touch Systems, Inc.
Packager: 3M Touch Systems, Inc. <us-ts-techsupport@mmm.com>
URL:  http://www.3MTouch.com

%{!?kernel: %define kernel %(uname -r)}
Source0:	TWDrvSources.tgz
Source1:	ReadmeKit.txt
ExclusiveOS:	Linux
BuildArch:	i686 i586 i486 i386
BuildRoot:	/var/tmp/%{name}-%{version}-root
Requires:	modutils
Requires:	grep

%description
TouchWare kernel device driver for 3M Touch Systems, Inc., touch screens with calibration tool

%prep
%setup -c %{name}-%{version} -T -a 0

%build

if [ -z "${KERNEL_RELEASE}" ]; then
  KERNEL_RELEASE=`uname -r | sed -e 's/smp//g'`
fi
                                                                                
echo "using $KERNEL_RELEASE"
echo ""

rm -rf $RPM_BUILD_ROOT

KVER=${KERNEL_RELEASE}; export KVER
cd TwDrvKit
make clean
make 

if [ "`echo ${KERNEL_RELEASE} | awk /^..6../`" != "" ]
then 
  MODULE_EXT="ko"
elif [ "`echo ${KERNEL_RELEASE} | awk /^..4../`" != "" ]
then
  MODULE_EXT="o"
else
  echo "Kernel version ${KERNEL_RELEASE} is not suported"
  exit 1
fi 

mkdir -p ${RPM_BUILD_ROOT}/lib/modules/${KVER}/kernel/drivers/input/touchscreen
install -o root -g root -m 555 TWDrv.${MODULE_EXT} ${RPM_BUILD_ROOT}/lib/modules/${KVER}/kernel/drivers/input/touchscreen
cd ..

cd mmtool
make && cp MultiMonitorTool ../bin
cd ..

cd TWCalib
make && cp TwCalib ../bin
cd ..

echo "reference kernel $KERNEL_RELEASE" > BUILTWITH
rpm -qa | grep gcc >> BUILTWITH
rpm -q binutils >> BUILTWITH
rpm -q make >> BUILTWITH
rpm -q rpm >> BUILTWITH

%pre
if [ "`uname -r`" != "%{kernel}" ]
then
    echo "This was built for kernel version %{kernel} you have version `uname -r`"
    exit 1;
fi

%install
mkdir -p ${RPM_BUILD_ROOT}/usr/X11R6/lib/modules/input
install -o root -g root -m444 Xfree4.0.3/TWXinput_drv.o ${RPM_BUILD_ROOT}/usr/X11R6/lib/modules/input

mkdir -p ${RPM_BUILD_ROOT}/etc/twscreen
install -o root -g root -m555 TWXinputInstall.perl ${RPM_BUILD_ROOT}/etc/twscreen

install -o root -g root -m555 install ${RPM_BUILD_ROOT}/etc/twscreen

mkdir -p ${RPM_BUILD_ROOT}/sbin
install -o root -g root -m555 daemon/TWDrvStartup ${RPM_BUILD_ROOT}/sbin

mkdir -p ${RPM_BUILD_ROOT}/etc/twscreen/TWCalib
install -o root -g root -m555 bin/TwCalib ${RPM_BUILD_ROOT}/etc/twscreen/TWCalib

install -o root -g root -m555 bin/MultiMonitorTool ${RPM_BUILD_ROOT}/etc/twscreen/TWCalib

mkdir -p ${RPM_BUILD_ROOT}/etc/init.d
install -o root -g root -m555 TWDrvStartup ${RPM_BUILD_ROOT}/etc/init.d

mkdir -p ${RPM_BUILD_ROOT}%_libdir
install -o root -g root -m555 lib/libMultiMonitor.so ${RPM_BUILD_ROOT}%_libdir

install -o root -g root -m555 lib/libTwCaliblib.so ${RPM_BUILD_ROOT}%_libdir

install -o root -g root -m555 lib/libTwGraphics.so ${RPM_BUILD_ROOT}%_libdir


%clean
if [ "$RPM_BUILD_ROOT" != "/" ]
then
    rm -rf $RPM_BUILD_ROOT
fi

%post

#############################################################################
# post install actions                                                      #
#############################################################################
/sbin/depmod -a
/sbin/modprobe TWDrv

MAJOR=`awk "\\$2==\"TWDrv\" {print \\$1}" /proc/devices`
# Check if kernel module was installed
if [ "${MAJOR}" != "" ] ; then
#
  for MODFILE in modprobe.conf modules.conf
  do
    if [ -f "/etc/${MODFILE}" ]
    then
      /bin/cp /etc/${MODFILE} /etc/${MODFILE}.tr && /bin/grep -v TWDrv /etc/${MODFILE}.tr >/etc/${MODFILE}
      grep -q char-major-${MAJOR} /etc/${MODFILE}
      if [ "$?" -eq 1 ]
      then
        echo "alias char-major-${MAJOR} TWDrv" >> /etc/${MODFILE}
        #If you have serial set value greater then zero
        echo "options TWDrv TWDrv_nMaxSerial=0" >> /etc/${MODFILE}
      fi
    fi
  done
  
  rm -f /dev/twscreen[0-3]
  for NUM in 0 1 2 3
  do
    if [ ! -c /dev/twscreen${NUM} ]
    then
      mknod -m 666 /dev/twscreen${NUM} c ${MAJOR} ${NUM}
    fi
    chmod 666 /dev/twscreen${NUM}
  done
  
  chkconfig --add TWDrvStartup
  /etc/init.d/TWDrvStartup start
else
  echo "We failed to install the TouchWare kernel driver"
  exit 1;
fi

%preun

#############################################################################
# pre uninstall actions                                                     #
#############################################################################
/etc/init.d/TWDrvStartup stop
chkconfig --del TWDrvStartup

%postun

#############################################################################
# post uninstall actions                                                    #
#############################################################################
/sbin/depmod -a

%files
%defattr(-, root, root)
/usr/X11R6/lib/modules/input/TWXinput_drv.o
/etc/twscreen/TWXinputInstall.perl
/etc/twscreen/install
/sbin/TWDrvStartup
/etc/init.d/TWDrvStartup
%_libdir/libMultiMonitor.so
%_libdir/libTwCaliblib.so
%_libdir/libTwGraphics.so
%dir /etc/twscreen
     /etc/twscreen/TWCalib
     /lib/modules/%{kernel}/kernel/drivers/input/touchscreen/
%doc BUILTWITH Readme.txt


%changelog
* Tue Apr 11 2006 - 3M Touch Systems, Inc. <us-ts-techsupport@mmm.com> 5.64.1.0
- New options in X input driver added to support different touch modes.

* Tue Oct 21 2005 - 3M Touch Systems, Inc. <us-ts-techsupport@mmm.com> 5.64.0.0
- Added multiple monitor support.

* Tue Apr 29 2005 - 3M Touch Systems, Inc. <us-ts-techsupport@mmm.com> 5.63.0.2
- Improved support for SC USB controllers

* Tue Mar 2 2005 - 3M Touch Systems, Inc. <us-ts-techsupport@mmm.com> 5.63.0.1
- Serial controllers search moved from kernel into user space

* Tue Feb 8 2005 - 3M Touch Systems, Inc. <us-ts-techsupport@mmm.com> 5.63.0.0
- Created installation for both 2.4 and 2.6 kernel
 
